//+------------------------------------------------------------------+
//|                                                Slider Single.mq4 |
//|                                    Created by Mimp (at forex-tsd)|
//|                                                                  |
//+------------------------------------------------------------------+

//*---------------------------------------------------------------------------------------------------------------------------------*
//| This indicator allows you to alter the period of any given indicator (displayed in a separate_window) by adjusting the location |
//| of a Marker in relation to a scale of boxes in the chart_window, to be used like a "slider". Each box is labelled with the value|   
//| (int) of a period which will be applied to the indicator in the separate_window if the Marker is placed within that box on the  |
//| chart. This saves time and effort of having to go through the hastle of multiple distracting clicks if you are trying to fine   |
//| tune the period of your indicator during testing, and provides a more intuitive understanding of the relation between many      |
//| periods (without having to have those many periods of the same indicator drawn on the screen at the same time).                 |
//| If you wish to apply the slider to a different indicator, simply change the indicator on line 383 and use the "IndicatorPeriod" |
//| variable where you would otherwise type the period for that indicator and remember to adjust the #properties below if necessary.|
//|                                                                                                                                 |
//| DISCLAIMER: Use this indicator at your own risk. Intended for optimization and backtesting only. Not intended for live trading. |
//|                                                                                                                                 |
//| Permission granted to alter, copy, distribute, improve or otherwise use my code here (for personal use, not for use in sale).   |       
//| Thanks to phy (mql4.com) for the idea of only redrawing visible bars. (Code copied from http://forum.mql4.com/9594/page2).      |
//| Thanks to mladen (forex-tsd) for helping to tackle updates per tick.                                                            |
//| Thanks to Drey (forex factory) for pointing out how to refresh by hotkey (when no ticks are available).                         |    
//| (See http://www.forexfactory.com/showthread.php?t=267385).                                                                      |
//|                                                                                                                                 |
//| NOTES:                                                                                                                          |   
//| The period will only respond to movements in the Marker every tick. The code considers the Marker to "be" in the corner of the  |
//| Marker selection box (where the little tiny square dot is). If you lose the Marker, you will need to reload the indicator. Do   |
//| not move the boxes once they have been drawn, because the Marker responds to their original X and Y co-ordinates. If you wish to|
//| draw the chart objects in a different place then adjust these settings (in the Internal Variables section) before loading the   |
//| indicator. If you wish to use the indicator while offline or during non-trading hours (when there are no ticks), then simply    |                     
//| refresh the chart every time you move the Marker to a new period (by pressing Alt+C+R). Do not use minus values for the boxes!  |                             
//*---------------------------------------------------------------------------------------------------------------------------------*

#property indicator_separate_window

#property indicator_buffers 1

#property indicator_color1 DodgerBlue

#property indicator_width1 1

#property indicator_maximum 100
#property indicator_minimum 0

//#property indicator_level1 50
//#property indicator_level2 30
//#property indicator_level3 70
//#property indicator_levelstyle STYLE_DOT
//#property indicator_levelcolor Red

// External variables

extern int Periods_from = 2;                    // Lowest period to be tested. Does not work with minus values.
extern int Periods_to = 50;                     // Highest period to be tested. Does not work with minus values.

extern color MarkerColour = Gold;
extern color BoxColour = Red;
extern color NumberColour = White;

// Internal variables                           // WARNING: The chart spacings may not automatically adjust if you change these.

int Corner = 2;                                 // Selects which corner of the chart the X and Y co-ordinates of objects relate to.
                                                // 0 = TopLeft, 2 = BottomLeft. To get the boxes to stick to the top of the chart, 
                                                // use 0. To get the boxes to stick to the bottom of the chart, use 2.
                                                
int StartValue_X = 50;                          // Default initial X co-ordinate for chart objects.
int StartValue_Y = 50;                          // Default initial Y co-ordinate for chart objects.

int Marker_StartValue_X = 50;                   // Adjust these up and down to move the objects in the chart window.
int Marker_StartValue_Y = 420;                  // WARNING: the marker will not update the period correctly if you
int Box_StartValue_X = 50;                      //          move objects around the chart once they have been drawn.
int Box_StartValue_Y = 420;                     //          If you wish to draw the chart objects in a different place
int Number_StartValue_X = 55;                   //          then adjust these settings before loading the indicator.
int Number_StartValue_Y = 420;                  //
int PeriodLabel_StartValue_X = 3;               //
int PeriodLabel_StartValue_Y = 24;              //

int IndicatorDefaultPeriod = 2;                 // The period which the indicator defaults to when the indicator is first loaded.
int NumberVerticalOffset = 20;                  // Distance of numbers above boxes.
int HorizontalOffset = 20;                      // Distance between boxes.
int MultipleLineVerticalOffset = 60;            // The vertical offset for each new row of boxes (if there are more than 50).
int TripleDigitsAdjust = 5;                     // The extra spacing between numbers if the period is in 3 digits.

int MarkerType = 115;                           // Windings number.
int MarkerSize = 20;
int BoxType = 111;                              // Windings number.
int BoxSize = 20;
string NumberFont = "Arial";
int NumberFontSize = 10;
string PeriodLabelFont = "Arial";
int PeriodLabelFontSize = 14;
color PeriodLabelColour = White;

// Program variables

int OnceOnlyToggle;
int Marker_CurrentValue_X;
int Marker_CurrentValue_Y;
int boxperiod;
int boxcounter;
int IndicatorPeriod;
string shortname;

// Arrays                                       // Arrays only have 200 indeces, so only periods 1-200 can be tested.

int BoxPeriod[200];                             // If you wish to test more than 200, then increase the number here, remove
int BoxLeft[200];                               // the alert warning at the begining of the start(), and add another "cycle
int BoxRight[200];                              // block" in the "OnceOnly" section of the code. Make sure to update the boxcounter
int BoxTop[200];                                // enumeration before the while condition, the while conditional values, AND most 
int BoxBottom[200];                             // importantly the relevant X and Y co-ordinates of the objects and the arrays.
                                                
//--- Buffers

double BufIndicator[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- 

   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,BufIndicator);
   
   shortname = "Slider Single";   
   IndicatorShortName(shortname);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
  
ObjectDelete("Marker");
ObjectDelete("PeriodLabel");
Comment("");

boxperiod = 0;
while ( boxperiod <= 1000)
{
ObjectDelete("Box_"+boxperiod);
ObjectDelete("Number_"+boxperiod);
boxperiod++;
}   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
	
	// Redraw indicator buffers only within the visible window ----
   for( int i = MathMax(WindowFirstVisibleBar(), Bars-IndicatorCounted()); i>= 0; i--)
   {  
//----


// ************************************************************************************************************************
// Code in this section only runs the first time the indicator is loaded --------------------------------------------------
if ( OnceOnlyToggle == 0 )
{
// ---- OnceOnlyToggle start ----------------------------------------------------------------------------------------------

// Warn if using more than periods 1 to 200 ----
if (
      ( Periods_to > 200 ) 
   )
   {
   Comment("!WARNING! To many periods have been selected as external variables. Only periods 1 to 200 can be tested.");
   Alert("!WARNING! To many periods have been selected as external variables. Only periods 1 to 200 can be tested.");
   Print("!WARNING! To many periods have been selected as external variables. Only periods 1 to 200 can be tested."); 
   } 
   
// Warn if Periods_to is less than Periods_from ----
if (
      ( Periods_to < Periods_from ) 
   )
   {
   Comment("!WARNING! Periods_to is set to less than Periods_from in the external variables. Indicator will not work properly like this.");
   Alert("!WARNING! Periods_to is set to less than Periods_from in the external variables. Indicator will not work properly like this.");
   Print("!WARNING! Periods_to is set to less than Periods_from in the external variables. Indicator will not work properly like this.");
   }    
  
// Set start co-ordinates ----

int Marker_StartValue_X = StartValue_X;                  
int Marker_StartValue_Y = StartValue_Y;                
int Box_StartValue_X = StartValue_X;                   
int Box_StartValue_Y = StartValue_Y;                   
int Number_StartValue_X = StartValue_X + 5;                 
int Number_StartValue_Y = StartValue_Y;                          
        
// Marker creation ----
   {
   ObjectCreate("Marker", OBJ_LABEL, 0, 0, 0);
   ObjectSet("Marker", OBJPROP_CORNER, Corner);
   ObjectSet("Marker", OBJPROP_XDISTANCE, Marker_StartValue_X);
   ObjectSet("Marker", OBJPROP_YDISTANCE, Marker_StartValue_Y);
   ObjectSetText("Marker",CharToStr(MarkerType),MarkerSize,"Wingdings",MarkerColour);
   }

// Box creation cycle for boxes 1 to 50 ----
boxcounter = 0;
while ( boxperiod <= 50 )
{
if (
      ( Periods_from <= boxperiod )
   && ( Periods_to >= boxperiod )
   )
   {
   ObjectCreate("Box_"+boxperiod, OBJ_LABEL, 0, 0, 0);
   ObjectSet("Box_"+boxperiod, OBJPROP_CORNER, Corner);   
   ObjectSet("Box_"+boxperiod, OBJPROP_XDISTANCE, Box_StartValue_X + (HorizontalOffset*(boxcounter+1)));
   ObjectSet("Box_"+boxperiod, OBJPROP_YDISTANCE, Box_StartValue_Y);
   ObjectSetText("Box_"+boxperiod,CharToStr(BoxType),BoxSize,"Wingdings",BoxColour);  
   ObjectCreate("Number_"+boxperiod, OBJ_LABEL, 0, 0, 0); 
   ObjectSet("Number_"+boxperiod, OBJPROP_CORNER, Corner);     
   ObjectSet("Number_"+boxperiod, OBJPROP_XDISTANCE, Number_StartValue_X + (HorizontalOffset*(boxcounter+1)));
   ObjectSet("Number_"+boxperiod, OBJPROP_YDISTANCE, Number_StartValue_Y - NumberVerticalOffset);     
   ObjectSetText("Number_"+boxperiod, ""+boxperiod, NumberFontSize, NumberFont, NumberColour);    
   BoxPeriod[boxcounter] = boxperiod;  
   BoxLeft[boxcounter] = (Box_StartValue_X + 25) + (HorizontalOffset*(boxcounter));
   BoxRight[boxcounter] =  (Box_StartValue_X + 39) + (HorizontalOffset*(boxcounter));  
   BoxTop[boxcounter] = Number_StartValue_Y + 7;
   BoxBottom[boxcounter] = Number_StartValue_Y + 20;      
   boxcounter++;   
   }
boxperiod++;                            
}

// Box creation cycle for boxes 50 to 100 ----
boxcounter = 50;
while ( 
         ( boxperiod > 50 )
      && ( boxperiod <= 100 )
      )
{
if (
      ( Periods_from <= boxperiod )
   && ( Periods_to >= boxperiod )
   )
   {
   ObjectCreate("Box_"+boxperiod, OBJ_LABEL, 0, 0, 0);
   ObjectSet("Box_"+boxperiod, OBJPROP_CORNER, Corner);       
   ObjectSet("Box_"+boxperiod, OBJPROP_XDISTANCE, Box_StartValue_X + (HorizontalOffset*(boxcounter-49)));
   ObjectSet("Box_"+boxperiod, OBJPROP_YDISTANCE, Box_StartValue_Y + MultipleLineVerticalOffset);
   ObjectSetText("Box_"+boxperiod,CharToStr(BoxType),BoxSize,"Wingdings",BoxColour);  
   ObjectCreate("Number_"+boxperiod, OBJ_LABEL, 0, 0, 0);  
   ObjectSet("Number_"+boxperiod, OBJPROP_CORNER, Corner);    
   ObjectSet("Number_"+boxperiod, OBJPROP_XDISTANCE, (Number_StartValue_X + (HorizontalOffset*(boxcounter-49))));
   ObjectSet("Number_"+boxperiod, OBJPROP_YDISTANCE, (Number_StartValue_Y - NumberVerticalOffset) + MultipleLineVerticalOffset);     
   ObjectSetText("Number_"+boxperiod, ""+boxperiod, NumberFontSize, NumberFont, NumberColour);    
   BoxPeriod[boxcounter] = boxperiod;  
   BoxLeft[boxcounter] = (Box_StartValue_X + 25) + (HorizontalOffset*(boxcounter-50));
   BoxRight[boxcounter] =  ((Box_StartValue_X + 39) + (HorizontalOffset*(boxcounter-50)));  
   BoxTop[boxcounter] = Number_StartValue_Y + 7 + MultipleLineVerticalOffset;
   BoxBottom[boxcounter] = Number_StartValue_Y + 20 + MultipleLineVerticalOffset;  
   boxcounter++;   
   }
boxperiod++;                            
}

// Box creation cycle for boxes 100 to 150 ----
boxcounter = 100;
while ( 
         ( boxperiod > 100 )
      && ( boxperiod <= 150 )
      )
{
if (
      ( Periods_from <= boxperiod )
   && ( Periods_to >= boxperiod )
   )
   {
   ObjectCreate("Box_"+boxperiod, OBJ_LABEL, 0, 0, 0);
   ObjectSet("Box_"+boxperiod, OBJPROP_CORNER, Corner);    
   ObjectSet("Box_"+boxperiod, OBJPROP_XDISTANCE, (Box_StartValue_X - 5) + ((HorizontalOffset+TripleDigitsAdjust)*(boxcounter-99)));
   ObjectSet("Box_"+boxperiod, OBJPROP_YDISTANCE, Box_StartValue_Y + (MultipleLineVerticalOffset*2));
   ObjectSetText("Box_"+boxperiod,CharToStr(BoxType),BoxSize,"Wingdings",BoxColour);  
   ObjectCreate("Number_"+boxperiod, OBJ_LABEL, 0, 0, 0); 
   ObjectSet("Number_"+boxperiod, OBJPROP_CORNER, Corner);       
   ObjectSet("Number_"+boxperiod, OBJPROP_XDISTANCE, ((Number_StartValue_X - 10) + ((HorizontalOffset+TripleDigitsAdjust)*(boxcounter-99))));
   ObjectSet("Number_"+boxperiod, OBJPROP_YDISTANCE, (Number_StartValue_Y - NumberVerticalOffset) + (MultipleLineVerticalOffset*2));     
   ObjectSetText("Number_"+boxperiod, ""+boxperiod, NumberFontSize, NumberFont, NumberColour);    
   BoxPeriod[boxcounter] = boxperiod;  
   BoxLeft[boxcounter] = (Box_StartValue_X + 20) + ((HorizontalOffset+TripleDigitsAdjust)*(boxcounter-100));
   BoxRight[boxcounter] =  ((Box_StartValue_X + 34) + ((HorizontalOffset+TripleDigitsAdjust)*(boxcounter-100)));  
   BoxTop[boxcounter] = Number_StartValue_Y + 7 + (MultipleLineVerticalOffset*2);
   BoxBottom[boxcounter] = Number_StartValue_Y + 20 + (MultipleLineVerticalOffset*2);  
   boxcounter++;   
   }
boxperiod++;                            
}

// Box creation cycle for boxes 150 to 200 ----
boxcounter = 150;
while ( 
         ( boxperiod > 150 )
      && ( boxperiod <= 200 )
      )
{
if (
      ( Periods_from <= boxperiod )
   && ( Periods_to >= boxperiod )
   )
   {
   ObjectCreate("Box_"+boxperiod, OBJ_LABEL, 0, 0, 0);
   ObjectSet("Box_"+boxperiod, OBJPROP_CORNER, Corner);    
   ObjectSet("Box_"+boxperiod, OBJPROP_XDISTANCE, (Box_StartValue_X - 5) + ((HorizontalOffset+TripleDigitsAdjust)*(boxcounter-149)));
   ObjectSet("Box_"+boxperiod, OBJPROP_YDISTANCE, Box_StartValue_Y + (MultipleLineVerticalOffset*3));
   ObjectSetText("Box_"+boxperiod,CharToStr(BoxType),BoxSize,"Wingdings",BoxColour);  
   ObjectCreate("Number_"+boxperiod, OBJ_LABEL, 0, 0, 0);
   ObjectSet("Number_"+boxperiod, OBJPROP_CORNER, Corner);        
   ObjectSet("Number_"+boxperiod, OBJPROP_XDISTANCE, ((Number_StartValue_X - 10) + ((HorizontalOffset+TripleDigitsAdjust)*(boxcounter-149))));
   ObjectSet("Number_"+boxperiod, OBJPROP_YDISTANCE, (Number_StartValue_Y - NumberVerticalOffset) + (MultipleLineVerticalOffset*3));     
   ObjectSetText("Number_"+boxperiod, ""+boxperiod, NumberFontSize, NumberFont, NumberColour);    
   BoxPeriod[boxcounter] = boxperiod;  
   BoxLeft[boxcounter] = (Box_StartValue_X + 20) + ((HorizontalOffset+TripleDigitsAdjust)*(boxcounter-150));
   BoxRight[boxcounter] =  ((Box_StartValue_X + 34) + ((HorizontalOffset+TripleDigitsAdjust)*(boxcounter-150)));  
   BoxTop[boxcounter] = Number_StartValue_Y + 7 + (MultipleLineVerticalOffset*3);
   BoxBottom[boxcounter] = Number_StartValue_Y + 20 + (MultipleLineVerticalOffset*3);  
   boxcounter++;   
   }
boxperiod++;                            
}

// ---- OnceOnlyToggle end ----------------------------------------------------------------------------------------------------
}
{ OnceOnlyToggle = 1; }
/// ---------------------------------------------------------------------------------------------------------------------------


// ****************************************************************************************************************************
// Code runs every tick from here onwards -------------------------------------------------------------------------------------

// Marker location check cycle. Checks location of Marker on screen and returns the period value of whichever box it is in ----
boxcounter = 0;
while ( boxcounter <= 200 )
{
if ( 
      ( ObjectGet("Marker", OBJPROP_XDISTANCE) >= BoxLeft[boxcounter] )
   && ( ObjectGet("Marker", OBJPROP_XDISTANCE) <= BoxRight[boxcounter] )  
   && ( ObjectGet("Marker", OBJPROP_YDISTANCE) >= BoxTop[boxcounter] ) 
   && ( ObjectGet("Marker", OBJPROP_YDISTANCE) <= BoxBottom[boxcounter] ) 
   )
   {
   IndicatorPeriod = BoxPeriod[boxcounter];
   Comment("Marker X = ", Marker_CurrentValue_X, ",  Marker Y = ", Marker_CurrentValue_Y, ",  Period = ", boxcounter+1);
   }
boxcounter++;
}

// Assign default period value to indicator if no box has been selected by the Marker ----
if (
      ( IndicatorPeriod == 0 )
   || ( IndicatorPeriod == EMPTY_VALUE )   
   )
   {
   IndicatorPeriod = IndicatorDefaultPeriod;
   }   

// Draw label to show selected indicator period ----
   {
   ObjectCreate("PeriodLabel", OBJ_LABEL, 0, 0, 0);  
   ObjectSet("PeriodLabel", OBJPROP_XDISTANCE, PeriodLabel_StartValue_X);
   ObjectSet("PeriodLabel", OBJPROP_YDISTANCE, PeriodLabel_StartValue_Y);     
   ObjectSetText("PeriodLabel", "Period = "+IndicatorPeriod, PeriodLabelFontSize, PeriodLabelFont, PeriodLabelColour);  
   }
   

// ******************************************************************************************************************************
// ** Insert your required buffer(s) here ** 
// Update and redraw indicator with new "IndicatorPeriod" variable value ----
   {
   BufIndicator[i] = iRSI(Symbol(), 0, IndicatorPeriod, PRICE_CLOSE, i);      
   WindowRedraw();   
   }
    
//----
}
   return(0);
  }
//+------------------------------------------------------------------+